#!/bin/bash

IN=`echo $1` #input sequence
UDIR=$2; #folder to keep intermediate results
#par1=`echo $1`
prefix=`echo ${IN%.*}`
suffix=`echo ${IN##*.}`

#export PATH=$PATH:/programs/Community/uclust
#export u=/programs/Community/uclust/usearch
#export UCHIME_REFDB=/programs/Community/uclust/gold.fa
export PATH=$PATH:$PWD
export u=$PWD/usearch
export UCHIME_REFDB=$PWD/gold.fa

if [ -f "$prefix.ucluster" ]; then
	rm $prefix.ucluster
fi
testdir=test$UDIR
mkdir ./$testdir

i=1
OUT=./$testdir/dist_$i
if [ ! -d $OUT ]; then
	mkdir $OUT
fi
# similarity level for clustering calculated from distance level
export PCTID_OTU=$((100 - ${i}))
#export PCTID_BIN=$((100 - ${i}))
#export PCTID_OTU=90;
#export PCTID_ERR=$((100 - ${i}))
./otupipe.bash $IN $OUT >> $OUT/uclust_log.txt
#done

DIR=".";
#for i in {1..10}
for (( i=1; i<=1; i++ ))
do
	TMP=$DIR/$testdir/dist_${i}/tmp;
	if [ ! -d "$TMP" ]; then
		echo $TMP;
		mkdir $TMP;
	fi
	# Create a file containing distance level info
#   if [ $i -le 9 ]; then
#		echo -n "0.0$i |" > $TMP/level.txt;
#	else
#		echo -n "0.$i |" > $TMP/level.txt;
#	fi
	# List unique cluster indices
	awk ' $1 ~ /[a-zA-Z]/ {print $2;}' $DIR/$testdir/dist_${i}/readmap.uc | sort -n | uniq | 
	while read cluster;
		do
			if [ "$cluster" != "*" ]; then # for non-outliers
			# For each cluster index, print out all seq indices in this cluster.
			# Use '|' as cluster separator.
			awk 'BEGIN { ORS=" "; } 
				 $2 == cl  {print NR-9;} 
				 END {print "|";}' cl="$cluster" $DIR/$testdir/dist_${i}/readmap.uc > $TMP/$cluster.tmp				 
			fi
	done
	
	# Merge all cluster files together into one file using "|" as cluster separator
	cat $TMP/*.tmp >> $prefix.ucluster
	echo "" >> $prefix.ucluster
	#rm -r $TMP;
done

rm -r ./$testdir

